//+------------------------------------------------------------------+
//|                                           II_Dragon_OC_Lines.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v 1.0 20/10/10
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Insanity Industries"
#property link      "http://www.insanityindustries.net"
#property indicator_chart_window

extern int force.tf=60;
extern int object.layer = 50;
extern int line.style = 0;
extern int line.width = 1;
extern bool show.history = true;
extern color color.high = LimeGreen;
extern color color.high.old = DarkGreen;
extern color color.low = Red;
extern color color.low.old = Maroon;


double point;

string TAG,pair;

datetime barstart;

double po,pc,o,c,h,l;

int tf;

int init(){
   if (object.layer>220) object.layer = 220;
   if(force.tf==0) tf = Period();
      else tf = force.tf;
   TAG = CharToStr(26+object.layer)+"II_Dragon_OC_Lines"+tf;
   pair = Symbol();
   point=Point;
   if(Digits==3||Digits==5) point*=10;
   barstart=0;
   Comment("");
   DoLogo();
   return(0);
}

int deinit(){
   ObDeleteObjectsByPrefix(TAG);
   return(0);
}

int start(){
   int i,j;
   color k;
   if(barstart<iTime(pair,tf,0)){
      barstart = iTime(pair,tf,0);
      int bars = iBars(pair,tf);
      ObDeleteObjectsByPrefix(TAG);
      for(i=bars-2;i>=1;i--){
// o-c>0 = red
         o=iOpen(pair,tf,i);
         c=iClose(pair,tf,i);
         po=iOpen(pair,tf,i+1);
         pc=iClose(pair,tf,i+1);
         if(o-c>0 && po-pc<0){ // red->green LOW/SUPPORT/DEMAND
            k = color.high;
            for(j=i-1;j>=1;j--){
               if(iHigh(pair,tf,j)>pc){
                  k = color.high.old;
                  if(show.history) DrawLine(iTime(pair,tf,i+1),iTime(pair,tf,j-1),i,pc,k);
                  break;
            }  }
            if(k==color.high) DrawLine(iTime(pair,tf,i+1),D'01.01.2019',i,pc,k);
         } else if(o-c<0 && po-pc>0){ //green->red HIGH/RESISTANCE/SUPPLY
            k = color.low;
            for(j=i-1;j>=1;j--){
               if(iLow(pair,tf,j)<pc){
                  k = color.low.old;
                  if(show.history) DrawLine(iTime(pair,tf,i+1),iTime(pair,tf,j-1),i,pc,k);
                  break;
            }  }
            if(k==color.low) DrawLine(iTime(pair,tf,i+1),D'01.01.2019',i,pc,k);
   }  }  }
   return(0);
}

void ObDeleteObjectsByPrefix(string Prefix){ // code by TRO
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()){
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix){ 
         i++; 
         continue;
      }
      ObjectDelete(ObjName);
}  }

void DrawLine(datetime t1, datetime t2,int i, double p, color c){
   string s = TAG+i;
   ObjectCreate(s,OBJ_TREND,0,0,0,0,0);
   ObjectSet(s,OBJPROP_COLOR,c);
   ObjectSet(s,OBJPROP_TIME1,t1);
   ObjectSet(s,OBJPROP_TIME2,t2);
   ObjectSet(s,OBJPROP_PRICE1,p);
   ObjectSet(s,OBJPROP_PRICE2,p);
   ObjectSet(s,OBJPROP_RAY,false);
   ObjectSet(s,OBJPROP_STYLE,line.style);
   ObjectSet(s,OBJPROP_WIDTH,line.width);
}

void DoLogo(){
   string TAG = CharToStr(0x61+27)+"II_Logo";
   if( ObjectFind(TAG+"ZZ"+0) >= 0 && ObjectFind(TAG+"ZZ"+1) >= 0 && ObjectFind(TAG+"ZZ"+2) >= 0  && 
       ObjectFind(TAG+"AZ"+0) >= 0 && ObjectFind(TAG+"AZ"+1) >= 0 && ObjectFind(TAG+"AZ"+2) >= 0 ) return;
   string str[3] = {"$","Insanity","Industries"};
   int size[3] = {25,10,10};
   int pos.x[3] = {47,19,17};
   int pos.y[3] = {10,25,15};
   int pos.xs[3] = {46,18,16};
   int pos.ys[3] = {9,24,14};
   for(int i=0;i<3;i++){
      string n = TAG+"ZZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",AliceBlue);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.x[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.y[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
      n = TAG+"AZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",Black);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.xs[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.ys[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
}  }

